#include <windows.h>
#include <stdio.h>
#include <time.h>

// user-defined constants

// user defined variables
DWORD dwInterval;
DWORD dwWidth = 50; // chars == 100%
DWORD dwPercent;
DWORD dwTickCount1, dwTickCount2;

BOOL init_variables(int argc, char **argv)
{
	if (argc <= 1) { dwInterval = 1000; }
	else
	{
		sscanf(argv[1], "%d", &dwInterval);
	}
	//gracefull return
	return TRUE;
}

void show_usage()
{
	printf("usage: cpuusage.exe [update_interval_in_miliseconds=1000]");
	return;
}

void update_cpu()
{
	dwPercent = rand();
	while (dwPercent > 100) { dwPercent /= 10; };


	dwTickCount2 = GetTickCount();
	// computes the percent load in deTickCount2 - dwTickCount1 100*nanosecs


}

void update_display()
{
	update_cpu();
	int p = dwWidth * dwPercent / 100;
	printf("\n%3d%%\t", dwPercent);
	for (;p > 0; p--)
	{
		printf("O");
	};
}

// main function
void main(int argc, char **argv)
{
	// init command line variables
	if (!init_variables(argc, argv))
	{
		show_usage();
		return;
	};

	// show a message
	printf("update interval: %d milis", dwInterval);

	srand((unsigned)time(NULL));

	// da run loop
	while (TRUE)
	{
		dwTickCount1 = GetTickCount();
		Sleep(dwInterval);
		update_display();
	};
}