/*
 killall - unix like program, copyright (c) Presura George, 2002-04-28
 args: killall "process name"
*/

#include <windows.h>
#include <stdio.h>
#include <psapi.h>

void CheckAndCloseProcess(DWORD processID, char * process_name)
{
	// check for ID - not less than 0
	if (processID <= 0)
	{
		return;
	};

	// variables
    char szProcessName[MAX_PATH] = "unknown";

    
	// Get a handle to the process.
    HANDLE hProcess = OpenProcess( PROCESS_QUERY_INFORMATION |
                                   PROCESS_VM_READ,
                                   FALSE, processID );

    // Get the process name
    if ( hProcess )
    {
        HMODULE hMod;
        DWORD cbNeeded;
        if ( EnumProcessModules( hProcess, &hMod, sizeof(hMod), &cbNeeded) )
        {
            GetModuleBaseName(hProcess, hMod, szProcessName, sizeof(szProcessName));
        }
    }

    // Print the process name and identifier.
    if ((strstr(strupr(szProcessName), strupr(process_name))) || (process_name[0] == '*'))
	{
		printf( "%s (Process ID: %u) ... ", szProcessName, processID );
		//try to kill
		unsigned int exit_code = 0;
		if (TerminateProcess(OpenProcess(PROCESS_TERMINATE, FALSE, processID), exit_code))
		{
			printf("OK (%i)\n", exit_code);
		}
		else
		{
			printf("FAILED\n");
		}
	};

    CloseHandle( hProcess );
}

int do_kill(char *process_name)
{
	//here's the code
    DWORD aProcesses[1024], cbNeeded, cProcesses;
    unsigned int i;

    if ( !EnumProcesses( aProcesses, sizeof(aProcesses), &cbNeeded ) )
        return 0;

    cProcesses = cbNeeded / sizeof(DWORD);
    for ( i = 0; i < cProcesses; i++ )
	{
		CheckAndCloseProcess(aProcesses[i], process_name);
	}
	return 0;
}

int main(int argc, char **argv)
{
	if (argc <= 1) { return 0; };
	// if we wanna kill everything ...
	return do_kill(argv[1]);
}
